:l eval2.l

; Evaluate the Towers of Hanoi
(define prog
	'(letrec
		((append2 (lambda (a b)
			(cond ((null? a) b)
				(#t (cons (car a) (append2 (cdr a) b))))))
		(append3 (lambda (a b c)
			(append2 a (append2 b c))))
		(hanoi (lambda (a b c n) (cond ((null? n) '())
			(#t (append3 (hanoi a c b (cdr n))
				(cons (cons a (cons b '())) '())
					(hanoi c b a (cdr n))))))))
		(hanoi 'a 'b 'c '(i i i))))

(eval prog '())

